//+------------------------------------------------------------------+
//|                                           BB Macd - zero lag.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  DimGray
#property indicator_color2  DimGray
#property indicator_color3  Lime
#property indicator_color4  Red
#property indicator_color5  Red
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2

//
//
//
//
//

extern int    FastLen   = 12;
extern int    SlowLen   = 26;
extern int    Length    = 10;
extern double StDv      = 1.0;
extern bool   drawDots  = false;

//
//
//
//
//

double buffer1[];
double buffer2[];
double bbMacd[];
double buffer4[];
double buffer5[];
double buffer6[];
double trend[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0, buffer1);
   SetIndexBuffer(1, buffer2);
   SetIndexBuffer(2, bbMacd);
   SetIndexBuffer(3, buffer4);
   SetIndexBuffer(4, buffer5);
   SetIndexBuffer(5, buffer6);
   SetIndexBuffer(6, trend);
      if (drawDots) {
            SetIndexStyle(2, DRAW_ARROW); SetIndexArrow(2, 159);
            SetIndexStyle(3, DRAW_ARROW); SetIndexArrow(3, 159);
            SetIndexStyle(4, DRAW_NONE);
         }
      else
         {
            SetIndexStyle(2, DRAW_LINE);
            SetIndexStyle(3, DRAW_LINE);
            SetIndexStyle(4, DRAW_LINE);
         }

   //
   //
   //
   //
   //
     
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   IndicatorShortName("BB Macd - zero lag (" + FastLen + "," + SlowLen + "," + Length+")");
      SetIndexLabel(0, "Upperband");
      SetIndexLabel(1, "Lowerband");  
      SetIndexLabel(2, "BB Macd");
      SetIndexLabel(3, NULL);
      SetIndexLabel(4, NULL);
   return(0);
}

int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;


   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = Bars - counted_bars;

      if (!drawDots)
      if (trend[limit]==-1) CleanPoint(limit,buffer4,buffer5);

   //
   //
   //
   //
   //
   
   for(i = limit; i >= 0 ; i--)
   {
      double macd   = 0;
      double signal = 0; CalculateMacd(i,macd,signal);
                         bbMacd[i]  = macd;
                         buffer6[i] = signal;
         
         //
         //
         //
         //
         //
         
         double sDev = iDeviation(bbMacd, buffer6[i], Length, i);
            buffer1[i] = buffer6[i] + (StDv * sDev);
            buffer2[i] = buffer6[i] - (StDv * sDev);
            buffer4[i] = EMPTY_VALUE;
            buffer5[i] = EMPTY_VALUE;
               
         //
         //
         //
         //
         //
               
         trend[i] = trend[i+1];
            if (bbMacd[i]<bbMacd[i+1]) trend[i] = -1;
            if (bbMacd[i]>bbMacd[i+1]) trend[i] =  1;
            if (trend[i] == -1)
               if (drawDots)     buffer4[i] = bbMacd[i];
               else  PlotPoint(i,buffer4,buffer5,bbMacd);
   }

   //
   //
   //
   //
   //
   
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workBuffer[][8];

#define ema11 0
#define ema12 1
#define ema21 2
#define ema22 3
#define ema31 4
#define ema32 5
#define imacd 6
#define isign 7

//
//
//
//
//

void CalculateMacd(int i, double& macd, double& signal)
{
   double alpha1 = 2.0/(1.0+FastLen);
   double alpha2 = 2.0/(1.0+SlowLen);
   double alpha3 = 2.0/(1.0+Length);
   int    r=Bars-i-1;

      if (ArrayRange(workBuffer,0)!=Bars) ArrayResize(workBuffer,Bars);
      
   //
   //
   //
   //
   //
         
   
   double price = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i);
   if (i==(Bars-1))
   {
      workBuffer[r][ema11] = price;
      workBuffer[r][ema12] = price;
      workBuffer[r][ema21] = price;
      workBuffer[r][ema22] = price;
      workBuffer[r][imacd] = 0;
      workBuffer[r][isign] = 0;
   }
   else
   {
      workBuffer[r][ema11] = workBuffer[r-1][ema11]+alpha1*(price               -workBuffer[r-1][ema11]);
      workBuffer[r][ema12] = workBuffer[r-1][ema12]+alpha1*(workBuffer[r][ema11]-workBuffer[r-1][ema12]);
      workBuffer[r][ema21] = workBuffer[r-1][ema21]+alpha2*(price               -workBuffer[r-1][ema21]);
      workBuffer[r][ema22] = workBuffer[r-1][ema22]+alpha2*(workBuffer[r][ema21]-workBuffer[r-1][ema22]);
      workBuffer[r][imacd] = (2.0*workBuffer[r][ema11]-workBuffer[r][ema12])-
                             (2.0*workBuffer[r][ema21]-workBuffer[r][ema22]);
 
      //
      //
      //
      //
      //
      
      workBuffer[r][ema31] = workBuffer[r-1][ema31]+alpha3*(workBuffer[r][imacd]-workBuffer[r-1][ema31]);
      workBuffer[r][ema32] = workBuffer[r-1][ema32]+alpha3*(workBuffer[r][ema31]-workBuffer[r-1][ema32]);
      workBuffer[r][isign] = (2.0*workBuffer[r][ema31]-workBuffer[r][ema32]);
   }
   macd   = workBuffer[r][imacd];
   signal = workBuffer[r][isign];
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iDeviation(double& array[],double dMA, int period,int shift)
{
   double dSum = 0.00;
   int    i;

   for(i=0; i<period; i++) dSum += (array[shift+i]-dMA)*(array[shift+i]-dMA);
   
   return(MathSqrt(dSum/period));
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}